# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Admserv.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Cobalt_dir = "/usr/httpd/html/cobalt";
my $Htconf = "/etc/httpd/conf";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Admserv.pm.  Changes made here will be lost.
package Cobalt::Admserv;

sub admserv_set_redirect
# Set the host and port to which the admin server gets redirected
# Arguments: name of the server host, port on which the admin server runs
# Side effects: modifies srm.conf, restarts httpd
# Return value: usual
# Example: Cobalt::Admserv::admserv_set_redirect("209.19.61.16",81);
{
  # This function is no longer used--we use mod_rewrite instead.
  return;

    my ($host,$port) = @_;
    my ($donc,$dond,$done,$donf,$dong,$donp,$dons);
    return "1001 Redirect not changed; httpd disabled"
      unless ($Features{'adm'});
    return "4005 /etc/httpd/conf/srm.conf is locked"
	if (-e "$Lockdir/srm.conf");
    open(HTCTMP,">$Lockdir/srm.conf")
	|| return "4006 Cannot write /etc/locks/srm.conf: $!";
    open(HTCONF,"$Htconf/srm.conf") 
	|| return "4007 Cannot read /etc/httpd/conf/srm.conf: $!";
    while (<HTCONF>)
    {
	if (/^Redirect \/.cobalt/o)
	{
	    # /.cobalt/ redirects web page accesses from the main server
	    # to the admin server
	    print HTCTMP "Redirect /.cobalt http://$host:$port/.cobalt\n";
	    $done = 1;
	}
	elsif (/^Redirect \/cgi-bin\/.cobalt/o)
	{
	    # /cgi-bin/.cobalt/ redirects CGI accessses to the admin server
	    print HTCTMP "Redirect /cgi-bin/.cobalt http://$host:$port/cgi-bin/.cobalt\n";
	    $donf = 1;
	}
	elsif ($Features{'personalRedirect'} && (/^Redirect \/personal/o))
	{
	    # /personal/ redirects web page accesses from the main server
	    # to the personal profile pages
	    print HTCTMP "Redirect /personal http://$host:$port/.cobalt/personal\n";
	    $donp = 1;
	}
	elsif ($Features{'adminRedirect'} && (/^Redirect \/admin/o))
	{
	    # /admin/ redirects web page accesses from the main server
	    # to the administrator site
	    print HTCTMP "Redirect /admin http://$host:$port/.cobalt/sysManage\n";
	    $donc = 1;
	}
	elsif ($Features{'siteAdminRedirect'} && (/^Redirect \/siteadmin/o))
	{
	    # /siteadmin/ redirects web page accesses from the main server
	    # to the site management site
	    print HTCTMP "Redirect /siteadmin http://$host:$port/.cobalt/siteManage/$MainGroup\n";
	    $dons = 1;
	}
	elsif ($Features{'cobaltRedirect'} && (/^Alias \/cobalt\//o))
	{
	    # Just record the fact that the alias is already set
	    print HTCTMP;
	    $dond = 1;
	}
	# not useful for new discussion group
#	elsif ($Features{'discuss'} && (/^Alias \/discuss/o))
#	{
	    # Just record the fact that the alias is already set
#	    print HTCTMP;
#	    $dong = 1;
#	}
	else
	{
	    print HTCTMP;
	}
    }

    # This part adds aliases and redirects if they weren't already there;
    # the above fixes existing lines in the config file.
    if ($Features{'adminRedirect'})
    {
      print HTCTMP "Redirect /admin http://$host:$port/.cobalt/sysManage\n"
	unless ($donc);
    }
    if ($Features{'siteAdminRedirect'})
    {
      print HTCTMP "Redirect /siteadmin http://$host:$port/.cobalt/siteManage/$MainGroup\n"
	unless ($dons);
    }
    if ($Features{'personalRedirect'})
    {
      print HTCTMP "Redirect /personal http://$host:$port/.cobalt/personal\n"
	unless ($donp);
    }
    if ($Features{'cobaltRedirect'})
    {
      print HTCTMP "Alias /cobalt/ $Cobalt_dir/\n" unless ($dond);
    }
    # not useful for new discussion group
#    if ($Features{'discuss'})
#    {
#      print HTCTMP "Alias /discuss/ $Discuss_html_dir/\n" unless ($dong);
#    }
    print HTCTMP "Redirect /.cobalt http://$host:$port/.cobalt\n"
	unless ($done);
    print HTCTMP "Redirect /cgi-bin/.cobalt http://$host:$port/cgi-bin/.cobalt\n" 
	unless ($donf);
    close HTCONF;
    close HTCTMP;
    rename("$Lockdir/srm.conf","$Htconf/srm.conf") 
	|| return "4008 Cannot update srm.conf: $!";
    Cobalt::Admserv::restart_httpd();
    return "2003 Updated admin server redirect";
}


1;
