# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Admserv.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Allow_cgis_file = "/etc/httpd/conf/ALLOW_USER_CGIS";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Admserv.pm.  Changes made here will be lost.
package Cobalt::Admserv;

sub admserv_set_user_cgis
# Turn CGI access for users on or off
# Arguments: 1 for on, 0 for off
# Side effects: creates the file which tells cgiwrap wether or not
#   to allow user CGIs.  cgiwrap just looks to see if the file
#   exists, and if it does it permits users to run CGIs in their
#   own area.
# Return value: the usual status string
# Example: Cobalt::Admserv::admserv_set_user_cgis(0);
{
    my ($turnon) = @_;

    return "1002 User CGIs not allowed on this system."
      unless ($Features{'www'});

    if ($turnon && -e $Allow_cgis_file)
    {
	return "2004 User CGIs were already enabled, no change";
    }
    elsif ($turnon)
    {
	open(ALLOW,">$Allow_cgis_file")
	    || return "4009 Cannot turn on user CGIs: $!";
	close ALLOW;
	return "2005 User CGIs are enabled";
    }
    elsif (-e $Allow_cgis_file)
    {
	unlink($Allow_cgis_file)
	    || return "4010 Cannot turn off user CGIs: $!";
	return "2006 User CGIs disabled";

    }
    else
    {
	return "2007 User CGIs were already disabled, no change.";
    }
}


1;
