# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $MailAccessDB = "/etc/mail/access";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_add_relay
# adds a relay to the access database, format:  "host/network/domain RELAY"
# Enables email relaying by host/network/domain only
# Arguments: array of network/domains
{
        my (@new) = @_;
        my ($relay,%exists);
	my ($notend) = 1;

        foreach $relay (@new)
        {
                $exists{$relay} = 1;
        }

        die "4067 Cannot lock relay access database: $!" if ( -e "$Lockdir/access" );

        open (DBWRITE, "> $Lockdir/access")
          || return "4068 Cannot write relay access database: $!";
        open (DBREAD, "$MailAccessDB")
          || return "4069 Cannot read relay access database: $!";

        while (<DBREAD>)
        {
		if ($notend)
		{
	                if (/Mail rejected due to possible SPAM/o)
	                {
	                        print DBWRITE;
	                }
	                elsif (/^(\S+)\s+RELAY/o)
	                {
	                        print DBWRITE "$1\tRELAY\n" unless ($exists{$1});
	                }
	                elsif (/^# Put custom additions below/o)
	                {
	                        foreach $relay (@new)
	                        {
	                                print DBWRITE "$relay\tRELAY\n";
	                        }
	                        print DBWRITE "# Put custom additions below (Do not change/remove this line).\n";
	                        $notend = 0;
	                }
			else
			{
				print DBWRITE;
			}
		}
                else
                {
                        print DBWRITE;
                }
        }

        close DBWRITE;
        close DBREAD;

	return "4070 Cannot write relay access database: $!" unless (-w $MailAccessDB);

	print STDERR "$MakeMap_cmd hash $MailAccessDB < $Lockdir/access" if ($Debug);
	system("$MakeMap_cmd hash $MailAccessDB < $Lockdir/access >>$Sauce_log 2>&1")
	  && return "4071 Cannot build virtual alias database: $!";

	rename("$Lockdir/access","$MailAccessDB") || return "4072 Cannot unlock relay access database: $!";

	Cobalt::Email::mail_sendmail_hup();

	return "2021 Email relay enabled successfully"
}


1;
