# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $EmailVirtUser = "/etc/virtusertable";
my $Lockdir = "/etc/locks";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_build_virtusertable
# Build the virtusertable database based on the entries in the
# virtusertable file 
# Arguments: a set of aliases to put in the table, in the form
#   of a hash table, $aliasname => aliasto
# Rewrites the virtusertable with whatever aliases it is given as an
#   argument, plus whatever it finds below the "custom additions below"
#   lines at the bottom.
# Return value: 0 on failure, 1 on success
{
	my(%aliases) = @_;
	my($alias,$html_list,$html_last);

	open(LOK,"> $Lockdir/virtusertable") || return 0;
	print LOK "$$\n$0"; close(LOK);

	foreach $alias (keys %aliases)
	{
		if ($alias =~ /^\@/o)
		{
			$html_last .= "$alias\t".$aliases{"$alias"}."\n";
		} else
		{
			$html_list .= "$alias\t".$aliases{"$alias"}."\n" if ($aliases{"$alias"});
		}
	}

	# read custom additions
	my $customLines;
	my $customLinesStart=0;
	open( OLDVRT, "<$EmailVirtUser" ) || return 0;
	while( <OLDVRT> ) {
	    if( /custom additions below/o ) { $customLinesStart=1; next; }
	    if( $customLinesStart ) { $customLines.=$_; }
	}
	close( OLDVRT );

	open(VRT,">$EmailVirtUser") || return 0; # Nul for failure
	print VRT "# This file is automatically generated\n";
	print VRT "# Please put custom changes at the end\n";
	print VRT "# Cobalt Networks 1998\n\n";
	print VRT $html_list.$html_last;
	print VRT "\n# Put custom additions below (Do not change/remove this line).\n";
	print VRT "$customLines";
	close(VRT);

	unlink("$Lockdir/virtusertable");
	
	system("$MakeMap_cmd hash $EmailVirtUser.db < $EmailVirtUser\n")
	  && return 0;

	return 1;
}


1;
