# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Ftp.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htgroup_dir = "/home/groups";
my $WWWuser = "httpd";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Ftp.pm.  Changes made here will be lost.
package Cobalt::Ftp;

sub Ftp_set_incoming_quota
# Sets the ftp/incoming directory quota, in blocks
# Arguments: site group name, quota
#   A quota 0 disables the anonymous write access to the incoming directory
# Return value: string, see user_mod in User.pm 
{
	my ($group,$quota) = @_;
	my ($ftpuser) = uc($group);

	# If, for whatever reason, the incoming directory was wiped..	
	if (! -d "$Htgroup_dir/$group/ftp/incoming")
	{
		mkdir("$Htgroup_dir/$group/ftp/incoming",0722);
		chown( (getpwnam($WWWuser))[2], (getgrnam($group))[2], "$Htgroup_dir/$group/ftp/incoming");
	}

	# Now set permissions
	if ($quota) {
		chmod(02773,"$Htgroup_dir/$group/ftp/incoming");
	} else {
		chmod(02770,"$Htgroup_dir/$group/ftp/incoming");
	}

	return(Cobalt::User::user_mod($ftpuser,'','',$quota));
}


1;
