# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Gtmp = "/etc/locks/gtmp";
my $Htgtmp = "/etc/locks/htgtmp";
my $Lockdir = "/etc/locks";
my $MainGroup = "home";
my %System_groups = ("tty","1","mail","1","httpd","1","root","1","gopher","1","squid","1","admin","1","ftp","1","kmem","1","nobody","1","disk","1","games","1","global","1","users","1","adm","1","Site-adm","1","daemon","1","wheel","1","bin","1","homes","1","lp","1","man","1","news","1","uucp","1","dip","1","mem","1","sys","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub group_del_nohome
# group_del:_nohome delete a group that does not have a home directory
# Arguments: the name of the group to delete
# Side effects: Removes the group from the group and htgroup file
# Return value: a status string of the form "604 Gotta dance!"
{
    my($name) = @_;
    return "4201 Group $name does not exist" unless (getgrnam($name));
    my $return;
    return "4202 Cannot modify $name: prohibited group"
        if (($System_groups{$name}) || ($name eq $MainGroup));
    return $return unless (($return = Cobalt::Group::lock_group()) =~ /^2/o);

    print STDERR "Cleaning from $Gtmp\n" if ($Debug);
    open(GROUP,$Gtmp) || return Cobalt::Group::group_abort("4283 Cannot open /etc/locks/gtmp: $!");
    open(GTMP,">$Lockdir/group") ||
        return Cobalt::Group::group_abort("4284 Cannot clobber /etc/locks/group: $!");
    "$name:" =~ /^$name:/;   # pre-compile the pattern
    while (<GROUP>)
    {
        print GTMP unless (//);
    }
    close GTMP;
    close GROUP;
    rename("$Lockdir/group",$Gtmp) ||
        return Cobalt::Group::group_abort("4285 Cannot rename /etc/locks/gtmp: $!");

    open(GROUP,$Htgtmp) || return Cobalt::Group::group_abort("4286 Cannot open /etc/locks/htgtmp: $!");
    open(GTMP,">$Lockdir/htgroup") ||
        return Cobalt::Group::group_abort("4287 Cannot clobber /etc/locks/htgroup: $!");
    "$name:" =~ /^$name:/;   # pre-compile, not in the loop
    while (<GROUP>)
    {
        print GTMP unless (//);
    }
    close GTMP;
    close GROUP;
    rename("$Lockdir/htgroup",$Htgtmp) ||
        return Cobalt::Group::group_abort("4288 Cannot rename /etc/locks/htgtmp: $!");

    return $return unless (($return = Cobalt::Group::commit_group()) =~ /^2/o);


    print STDERR "Completed deletion of $name\n" if ($Debug);
    return "2231 Group deleted successfully";
}


1;
