# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Group.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Smbconf = "/etc/smb.conf";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Group.pm.  Changes made here will be lost.
package Cobalt::Group;

sub samba_del
# Removes a share from the samba configuration file
# Arguments: share name (generally the group name)
# Side effects: modifies smb.conf
{
    my ($share) = @_;
    return "1256 Samba is not enabled on this system" 
      unless ($Features{'smb'});
    return "4235 Samba config file /etc/smb.conf is locked; try again later" if (-e "$Lockdir/smb.conf");
    open(SMB,"$Smbconf") 
	|| return "4230 Cannot modify samba config file /etc/smb.conf: $! ";
    open(SNB,">$Lockdir/smb.conf") 
	|| return "4231 Cannot write samba config file /etc/locks/smb.conf: $! ";
    # compile the expression now, not each time we loop
    ";$share BEGIN" =~ /;$share BEGIN/; 
    while (<SMB>)
    {
	last if (//);
	print SNB;
    }
    # compile the expression now, not each time we loop
    ";$share END" =~ /;$share END/;  
    while (<SMB>)
    {
	last if (//);
    }
    print SNB while (<SMB>);
    close SMB;
    close SNB;
    rename("$Lockdir/smb.conf",$Smbconf) ||
	return "4232 Cannot update /etc/smb.conf: $!";
    return "2258 Removed SMB share";
}


1;
