# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Nat.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Filter_script = "/etc/rc.d/init.d/ipfilters";
my $Lockdir = "/etc/locks";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Nat.pm.  Changes made here will be lost.
package Cobalt::Nat;

sub nat_disable_masq
# Disable IP masquerading for an interface
# Arguments: interface name or (IP, netmask)
#   We accept both forms because there isn't really a network interface
#   associated with the modem (at least, not one the sauce understands).
# Return value: message of the form "3124 I require pudding"
# Side effects: Removes rules from the IP filtering rules to masquerading on
#   this interface
# Example: nat_enable_masq("eth0");
{
  # Handle arguments
  my ($n_addr,$n_mask);
  if ($#_) {
    # Arguments given were IP and netmask
    ($n_addr,$n_mask) = @_;
    $n_mask = Cobalt::Network::net_convert_netmask($n_mask) 
      if ($n_mask =~ /\./o); # decimalize dotted quad netmasks
  } else {
    # Argument was the interface name
    my ($netif) = @_;
    ($n_addr,$n_mask) = Cobalt::Network::net_get_ipaddr($netif);
  }

  return "4742 The filtering rules are being edited.  Try again later." if (-e "$Lockdir/ipfilters");
  open(NATOUT,">$Lockdir/ipfilters")
    || return "4745 Cannot write new filtering rules: $!";
  open(NATIN,"$Filter_script") || return "4746 Cannot read IP filters configuration: $!";
  my ($in_masq_section,$masq_set);
  # Scan through the ip filters rules for the masquerading rule
  while (<NATIN>) {
    unless (/-S $n_addr\/$n_mask \# masq/) {
      print NATOUT;
    }
  }
  close NATOUT;
  close NATIN;
  rename("$Lockdir/ipfilters",$Filter_script)
    || return "4747 Cannot write IP filter rules: $!";
  # The chmod will be done by nat_set_rules

  # Now rebuild the rules to make sure all the -m's are in the
  # right place.
  return Cobalt::Nat::nat_set_rules(Cobalt::Nat::nat_get_default(),
				    Cobalt::Nat::nat_get_rules());
}


1;
