# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Network.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Netif = "eth0";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Network.pm.  Changes made here will be lost.
package Cobalt::Network;

sub net_get_hostname
# Get the hostname
# Arguments: optional interface (e.g., "eth1")
# Return value: a string containing the hostname (unqualified)
# Side effects: none
{
  my ($netif) = @_;
  my $name;
  if ((defined($Features{'noinventhostnames'}) && $Features{'noinventhostnames'})
	|| ((! $netif) || ($netif eq $Netif))) {
    # if (noinventhostnames), always return official host name;  also, 
    # primary interface gets the official host name
    open(NAME,"/proc/sys/kernel/hostname") ||
	return "4351 Cannot read /proc/sys/kernel/hostname: $!";
    chomp($name = <NAME>);
    close NAME;
  }
  else {
    # I'm not the primary interface, look my name up
    my ($addr) = Cobalt::Network::net_get_ipaddr($netif);
    # Whoops, did I just hardcode AF_INET as 2?  Damn...
    ($name) = gethostbyaddr(pack('C4',split('\.',$addr)),2);
    $name ||= "cobalt-$netif";
  }
  my ($domain);
  if (($domain = (Cobalt::Network::net_get_dnsclient())[0])
      && ($name =~ /$domain$/))
  {
    $name =~ s/\.?$domain$//;
  }
  return $name;
}


1;
