# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Quota.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $BytesPerBlock = "1024";
my $Df_cmd = "/bin/df";
my $Htgroup_dir = "/home/groups";
my $MaxQuota = "10240000";
my $Q_GETQUOTA = "768";
my $SYS_quotactl = "4131";
my $Userpart = "/dev/hda4";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Quota.pm.  Changes made here will be lost.
package Cobalt::Quota;

sub repquota
# Report on the quota for a user or group
# Arguments: user/group name and type (type=0 for user, 1 for group)
#   Optional args: ID, homedir
#   If ID and homedir are not given, read them from the password or
#   group file.
# Return value: array: (used, soft limit, hard limit)
# In practice, hard limit and soft limit will always be the same
# Example: ($used,$soft,$hard) = Cobalt::Quota::repquota("john",0,9124,"/home/users/john");
{
    my ($user,$type,$id,$home) = @_;
    return "1004 Quotas not implemented" unless ($Features{'quotas'});
    unless ($id) {
      if ($type)
      {
	($id) = (getgrnam($user))[2];
	$home = "$Htgroup_dir/$user";
      }
      else
      {
	($id,$home) = (getpwnam($user))[2,7];
      }
    }
    my ($dqblk)  = pack("LLLLLLLL",0,0,0,0,0,0,0,0); 
    my $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_GETQUOTA,$type+0),
		     $Userpart,$id+0,$dqblk); 
    return "4760 Cannot get quota for $id: $!" if ($stat);
    my (@vals) = unpack("LLLLLLLL",$dqblk);
    # The UI doesn't understand that 0 means no quota, so instead of returning
    # 0 to indicate no quota, we return a really big number (e.g. the size of 
    # the disk)
    unless ($vals[0] && $vals[1]) {
      my $maxquota;
      $home = $Htgroup_dir unless (-d $home);
      if (open (DF, "$Df_cmd $home|")) {
	my $header = <DF>; # toss the header line
	while (<DF>) {
	  $maxquota = (split(/\s+/o))[3];
	  # make sure it's divisible by the size of a block
	  $maxquota = int($maxquota / $BytesPerBlock) * $BytesPerBlock; 
	}
	close DF;
      }
      $maxquota ||= $MaxQuota; # couldn't df for some reason (no home directory?)
      $vals[0] = $maxquota unless ($vals[0]);
      $vals[1] = $maxquota unless ($vals[1]);
    }
    return($vals[2],$vals[1],$vals[0]);
}


1;
