# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Quota.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Q_GETQUOTA = "768";
my $Q_SETQLIM = "1792";
my $Q_SYNC = "1536";
my $SYS_quotactl = "4131";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Quota.pm.  Changes made here will be lost.
package Cobalt::Quota;

sub setqlim
# Set the quota for a user or group
# Arguments: device on which to set quotas, uid, soft limit, hard limit,type
#   (type = 0 for users, 1 for groups)
# Side effects: modifies the quota tables
{
    my ($dev,$uid,$soft,$hard,$type) = @_;
    return "1003 Quotas not implemented" unless ($Features{'quotas'});
    my ($stat);
    my ($dqblk)  = pack("LLLLLLLL",0,0,0,0,0,0,0,0); 
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_GETQUOTA,$type),$dev,$uid+0,$dqblk); 
    return "4753 Cannot get quota for UID $uid: $!" if ($stat);
    my (@vals) = unpack("LLLLLLLL",$dqblk);
    $vals[1] = $soft;
    $vals[0] = $hard if ($soft);
    $dqblk  = pack("LLLLLLLL",@vals); 
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_SETQLIM,$type),$dev,$uid+0,$dqblk); 
    return "4756 Cannot set quota for UID $uid: $!" if ($stat);
    $stat=syscall($SYS_quotactl,Cobalt::Quota::QCMD($Q_SYNC,$type),$dev,$uid+0,$dqblk); 
    return "4757 Cannot sync quota for UID $uid: $!" if ($stat);
    return "2099 Quota set for $uid";
}


1;
