# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Repair.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $DiskRed = "90";
my $DiskYel = "80";
my $LoadRed = "6";
my $LoadYel = "3";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Repair.pm.  Changes made here will be lost.
package Cobalt::Repair;

sub repair_get_message
# Given the flags from the monitoring database, return the message.
#   This message should provide advice on how the user should deal
#   with the problem at hand.
# Arguments: service, instance
# Return value: message string
{
    my ($service,$instance) = @_;
    my $return;

    # Messages use these variables
    # eval will barf if these are not defined
    my $DiskRed=$DiskRed;
    my $DiskYel=$DiskYel;
    my $LoadRed=$LoadRed;
    my $LoadYel=$LoadYel;

    # We're really only interested in the $data fields
    my ($condition,$cond_time,$update_time,$notified,$attempts,
	$reserved,$data) = Cobalt::Monitor::mon_get_state($service,$instance);
    
    # Handle a few special cases, but pretty much generalize
    # the loop
    if ($service eq "groupspace") # user quota
      {
	# $instance is the group or site name
	# $data is (percentage of quota used, amount used, limit)
	my $name;
	my @data = split(/,/o,$data);
	if($Features{'vsites'}) {
	  $name = ( Cobalt::Vhost::vsite_get( Cobalt::Vhost::vsite_get_bygroup($instance) ) )[2];
	  $name ||= $instance;	# Group name better than no name 
	  $return = Cobalt::Language::msg_get("mon_sitespace_body");
	  $return = eval "\"$return\"";
	  return $return;
	}
	else {
	  $name = $instance;	# group name is the instance
	  $return = Cobalt::Language::msg_get("mon_${service}_body");
	  $return = eval "\"$return\"";
	  return $return;
	}
	
      }
    elsif ($service eq "dns")
      {
	if ($instance eq "nslookup") # can't resolve our name
	  {
	    return Cobalt::Language::msg_get("mon_dns_nslookup_body");
	  }
	else
	  {
	    my @data = split(/,/o,$data);
	    $return = Cobalt::Language::msg_get("mon_${service}_body");
	    $return = eval "\"$return\"";
	    return $return;
	  }
      }
    elsif ($service eq "mail")	# mail server
      {
	if    ($instance eq "smtp") # SMTP server
	  {
	    return Cobalt::Language::msg_get("mon_mail_smtp_body");
	  }
	elsif ($instance eq "pop3") # POP3 server (run via inetd)
	  {
	    return Cobalt::Language::msg_get("mon_mail_pop3_body");
	  }
	elsif ($instance eq "imap") # IMAP server (run via inetd)
	  {
	    return Cobalt::Language::msg_get("mon_mail_imap_body");
	  }
	else
	  {
	    return Cobalt::Language::msg_get("mon_mail_body");
	  }
      }
    else {
      my @data = split(/,/o,$data);
      $return = Cobalt::Language::msg_get("mon_${service}_body");
      $return = eval "\"$return\"";
      return $return;
    }
}


1;
