# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Repair.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Repair.pm.  Changes made here will be lost.
package Cobalt::Repair;

sub repair_get_subject
# Build the subject line for alert email
# Arguments: server, instance
# Side effects: none
# Return value: A message string
{
    my ($service,$instance,$flags) = @_;
    my $return;
    if (($service eq "userspace") || ($service eq "mailspace"))
      {
	$return = Cobalt::Language::msg_get("mon_${service}_subject");
	$return = eval "\"$return\"";
	return $return;
      }
    elsif ($service eq "groupspace") # group quota
      {
	if($Features{'vsites'})
	  {
	    my($siteHostname) = ( Cobalt::Vhost::vsite_get( Cobalt::Vhost::vsite_get_bygroup($instance) ) )[2];
        $siteHostname ||= $instance; # Group name better than no hostname 
	$return = Cobalt::Language::msg_get("mon_sitespace_subject");
	$return = eval "\"$return\"";
	return $return;
      } else {
	$return = Cobalt::Language::msg_get("mon_groupspace_subject");
	$return = eval "\"$return\"";
	return $return;
      }
    }
    elsif ($service eq "filesystem")
    {
      return Cobalt::Language::msg_get("mon_filesystem_subject");
    }
    $return = Cobalt::Language::msg_get("mon_subject");
    $return = eval "\"$return\"";
    return $return;
}


1;
