# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Repair.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Smb_testparm = "/usr/bin/testparm";
my $Smbconf = "/etc/smb.conf";
my $Smbd = "/usr/sbin/smbd";
my $Smbscript = "/etc/rc.d/init.d/smb";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my %Servers = ("smb","Windows file sharing (SMB)","mail","Email","filesystem","Disk","www","Web Server","dns","Domain Name Service (DNS)","net","Network","nfs","Unix file sharing (NFS)","cpu","CPU","ftp","File Transfer Protocol (FTP)","userspace","Quota","telnet","Telnet server","atalk","Apple file sharing (AppleShare)","modem","Modem","adm","Administrative Web Server","ntp","Network Time Protocol (NTP)","ssl","Secure Web Server","groupspace","Quota","snmp","Simple Network Management Protocol (SNMP)","mem","Memory");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Repair.pm.  Changes made here will be lost.
package Cobalt::Repair;

sub repair_smb
# Fix the samba server
# Arguments: none
# Side effects: tries to restart samba, tries to fix the config file
# Return value: status string
{
    my ($badlines);
    
    return "1702 SMB not supported" unless ($Features{'smb'});
    # kludge because testparm demands a "hit return to continue" and
    # open2 is soooo annoying
    open(TP,"$Smb_testparm < /proc/version |")
      || return "4712 Cannot run /usr/bin/testparm: $!";
    while (<TP>)
      {
	$badlines++ if (/^Unknown parameter encountered/o);
      }
    close TP;
    print STDERR "$badlines bad lines in samba config file\n" if ($Debug);
    
    # if too many bad lines, or the file is too small, replace it
    if (($badlines > 2) || ((stat($Smbconf))[7] < 400))
      {
	# take punitive action
	print LOG "<FONT COLOR=\"red\">", $Servers{'smb'},
	", ", Cobalt::Language::msg_localtime(time()), "<!-- $badlines -->",
	": Rebuilding config file $Smbconf from master copy</FONT>\n";
	rename($Smbconf,"$Smbconf.$^T"); # keep bad copy
	open(SRC,"$Smbconf.master")
	  || return "3714 Cannot read samba master file /etc/smb.conf.master: $!";
	open(DEST,">$Smbconf") 
	  || return "3715 Cannot write samba config file /etc/smb.conf: $!";
	print DEST while (<SRC>);
	close DEST;
	close SRC;
      }
    
    return Cobalt::Repair::repair_generic("smb",$Smbd,$Smbconf,
			  $Smbscript,139,0);
}


1;
