# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Security.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Access_file = ".htaccess";
my $Adm_Authname = "CobaltAdmin";
my $Adminuser = "admin";
my $Htgroup = "/etc/htgroup";
my $Htpasswd = "/etc/htpasswd";
my $Users_dir = "/usr/admserv/html/.cobalt/users";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Security.pm.  Changes made here will be lost.
package Cobalt::Security;

sub security_set_user_management
# Allow or disallow anyone in the world to manage users
# Arguments: 1 to allow anyone in the world to manage users,
#   0 to allow only user "admin" to manage users
# Return value: usual string of form "785 Green is a pretty color"
# Side effects: creates or deletes .htaccess files as appropriate
{
    my ($setting) = @_;
    return "1400 Users not implemented" unless ($Features{'users'});
    if ($setting)
    {
	# allow anyone
	if (! -e "$Users_dir/$Access_file")
	{
	    return "2441 No change to user management";
	}
	else 
	{
	    unlink("$Users_dir/$Access_file") ||
		return "4401 Cannot delete Users_dir/.htaccess: $!";
	    return "2447 Anyone in the world can manage users";
	}
    }
    else
    {
	# allow admin only
	if (-e "$Users_dir/$Access_file")
	{
	    return "2443 No change to user management";
	}
	else 
	{
	    open(UXS,">$Users_dir/$Access_file") ||
		return "4402 Cannot write Users_dir/.htaccess: $!";
	    print UXS "<LIMIT GET>\norder allow,deny\nallow from all\n";
	    print UXS "require user $Adminuser\n</LIMIT>\n";
	    print UXS "Authname $Adm_Authname\n";
	    print UXS "Authtype Basic\nAuthUserFile $Htpasswd\n";
	    print UXS "AuthGroupFile $Htgroup\n";
	    close UXS;
	    return "2449 Only the administrator may manage users";
	}
    }
}


1;
