# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Named_boot = "/etc/named.boot";
my $Named_dir = "/etc/named";
my $Named_disabled = "/etc/named.disabled";
my $Named_script = "/etc/rc.d/init.d/named";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Subsys = "/var/lock/subsys";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_dns_server_on
# Turn the dns server on or off
# Arguments: 1 for on, 0 for off
# Side effects: creates or removes /etc/named.boot, runs or kills named
{
    my ($state) = @_;

    return "1103 DNS service is not implemented in this release"
      unless ($Features{'dns'});

    if ($state)
    {
        if (-e "$Named_disabled")
	{
            rename($Named_disabled,$Named_boot)
		|| return "4850 Cannot copy /etc/named.disabled to /etc/named.boot: $!";
            unless (system("$Named_script start >>$Sauce_log 2>&1"))
	    {
                return "2850 DNS server started";
	    }
            else
	    {
                return "4851 DNS server start failed: $!";
	    }
	}
        elsif (-e "$Named_boot")
        {
            return "2856 No change -- the DNS server was already on";
        }
        else
        {
            # Create fresh new named.boot
            my($named_boot,$srv);
            $named_boot = "directory\t$Named_dir\n\ncache\t.\tdb.cache\n";
            open(NAMED,"> $Named_boot")
		|| return "4852 Cannot write to /etc/named.boot: $!";
            print NAMED $named_boot;
            close(NAMED);
            $srv = system("$Named_script start >>$Sauce_log 2>&1");

            if (!$srv)
	    {
		return "2852 DNS server started";
	    }
            else
	    {
                return "4853 DNS server start failed: $!";
	    }
	}
    }
    else
    {
        if (-e "$Named_boot")
	{
	    my $srv = system("$Named_script stop >>$Sauce_log 2>&1");
	    unlink( "$Subsys/named" ) if (-f "$Subsys/named" );
	    
	    rename($Named_boot,$Named_disabled)
		|| return "4856 Cannot rename /etc/named.boot to /etc/named.disabled: $!";
	    if (!$srv)
	    {
		return "2854 DNS server stopped";
	    }
	    else
	    {
		return "4854 DNS server stop failed: $!";
	    }
	}
        else
	{
	    return "2855 No change -- the DNS server was already off";
	}
    }
    return 1;
}


1;
