# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Services.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lcdshowscript = "/etc/rc.d/init.d/showip";
my $SNMPlink = "/etc/rc.d/rc3.d/S40snmpd";
my $SNMPscript = "/etc/rc.d/init.d/snmpd";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Services.pm.  Changes made here will be lost.
package Cobalt::Services;

sub set_snmp_server_on
# Turn the snmp server on or off
# Arguments: 1 for on, 0 for off
# Return value: a status string of the form "911 Invalid hormone balance."
# Side effects: creates or breaks symlinks in /etc/rc.d/rc3.d
{
    my ($state) = @_;

    return "1403 SNMP not implemented in this release"
      unless ($Features{'snmp'});

    if ($state && (! -e $SNMPlink))
    {
        my $pid;
        if (!defined($pid = fork)) {
            die "cannot fork: $!";
        } elsif ($pid) {
            # i'm the parent
            print STDERR "Forking to restart snmpd\n" if ($Debug);
            return "2461 SNMP agent started";
        }
        else
        {
            # otherwise I'm the child
            open(STDERR,">>$Sauce_log");
            open(STDOUT,">>$Sauce_log");
            symlink($SNMPscript,$SNMPlink) ||
	      die "4487 Cannot create link /etc/rc.d/rc3.d/S40snmpd: $!";
            system ("$SNMPscript start >> $Sauce_log 2>&1") &&
	      die "3498 Cannot start SNMP agent: $!";
            system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
            exit;
        }
    }
    elsif ((! $state) && (-e $SNMPlink))
    {
        unlink($SNMPlink) ||
            return "4488 Cannot break link /etc/rc.d/rc3.d/S40snmpd: $!";
        system ("$SNMPscript stop >> $Sauce_log 2>&1") &&
            return "3499 Cannot stop SNMP agent: $!";
        system ("$Lcdshowscript start >> $Sauce_log 2>&1")
	      if (-x $Lcdshowscript);
        return "2462 SNMP agent stopped";
    }
    else
    {
        my $off;
        ($state) ? ($off = Cobalt::Language::msg_get('On_string')) : 
	  ($off = Cobalt::Language::msg_get('Off_string'));
        return "2463 No change -- SNMP agent was already $off";
    }
}


1;
