# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Time.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $NtpConf = "/etc/ntp.conf";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Time.pm.  Changes made here will be lost.
package Cobalt::Time;

sub ntp_set_servers
# Define a list of ntp servers
# Arguments: array of fully qualified time server names or ip addresses
# Return value: string of the form "2123 Please use open policy servers"
# Side effects: edits /etc/ntp.conf
{
    my(@NtpServers) = reverse(@_);
    return "4625 ntp is not available in this release" unless ($Features{'ntp'});
    return "4626 ntp configuration is not available" unless (-e "$NtpConf");
    return "4627 ntp server is locked" if (-e "$Lockdir/ntp.conf");

    my($ntpServer,$NewServers,%ExistServer);
    while ($#NtpServers >= 0) 
    {
	$ntpServer = pop(@NtpServers); # foreach $ntpServer (@NtpServers

	next if ($ExistServer{"$ntpServer"});

	if ($ntpServer =~ /[a-zA-Z]/)
	{
		return "4628 Invalid ntp server name: $ntpServer" unless (Cobalt::Netutil::netutil_test_domainname($ntpServer));
		$NewServers .= "server\t$ntpServer\n";
	} elsif ($ntpServer =~ /\d/) {
		return "4629 Invalid ntp server IP address: $ntpServer" unless (Cobalt::Netutil::netutil_test_ipaddr($ntpServer));
		$NewServers .= "server\t$ntpServer\n";
	}
	$ExistServer{"$ntpServer"} = 1; # Don't want duplicate entries
    }
    return "4630 Please specify a valid NTP server" unless ($NewServers);

    open(NTPLCK,"> $Lockdir/ntp.conf");
    open(NTPCNF,"$NtpConf");
    while(<NTPCNF>)
    {
	if (/^server/)
	{
	    print NTPLCK $NewServers;
	    $NewServers = '';  
	} else {
	    print NTPLCK;
	}
    }
    close(NTPCNF);
    close(NTPLCK);
    rename("$Lockdir/ntp.conf","$NtpConf") || return "4631 Could not update ntp configuration file";

    return "2630 NTP servers updated";
}


1;
