# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Time.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Alias_db = "/etc/aliases.db";
my $Issuefile = "/etc/issue";
my $NtpDate = "/usr/sbin/ntpdate";
my $NtpcConf = "/etc/ntpc.conf";
my $NtpcCron = "/etc/cron.daily/ntpdate.auto";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Time.pm.  Changes made here will be lost.
package Cobalt::Time;

sub ntpc_set
# Schedules a ntpdate update, remembers the ntp server if updates are disabled\
# Arguments: 1 or 0 for enable updates or disable, ntp server name
# Return value: String, of the form "4324 That's it. I'm moving to Jamaica."
# Calling this with status of 1 ntpdates immediately to test the server
{
	my($status,$server) = @_;

	# Use old server if none specified but enabled updates
	if ($status && !$server && (-e "$NtpcConf"))
	{
                open(NTPC,"$NtpcConf");
                chomp($server = <NTPC>);
                close(NTPC);
	}

	if (Cobalt::Netutil::netutil_test_netaddr("$server")) 
	{
		open(NTPC,"> $NtpcConf");
		print NTPC "$server\n";
		close(NTPC);
	} elsif ($status) 
	{
		return "4633 Invalid ntp server name";
	}

	if ($status)
	{
		if( Cobalt::Netutil::netutil_ping( $server )!~/^2/ ) {
		    return "4659 NTP server is unreachable";
		}

		my($ret) = `$NtpDate $server 2>&1`;
		if ($ret =~ /no server suitable for synchronization/)
		{
			return "4657 The NTP server could not be contacted";
		} elsif ($ret =~ /t adjust the time of day: Invalid/)
		{
			return "4658 NTP update failed, the current date is too inaccurate.  The date and time must be updated manually.";
		}
		return "4632 Could not refresh time from $server" unless ($ret =~ /[adjust|step] time server/);

		# Fix the timestamp in /etc/issue, because monitor uses it
		# to tell how long ago we finished booted up
		utime($^T,$^T,$Issuefile);
		# Fix the timestamp on the aliases db, because we auto-rebuild 
		# based on it being older than /etc/aliases
		utime($^T,$^T,$Alias_db) if ($Features{'mail'});

		# Now make the cute little shell script that keeps us synced
		open(NTCRON,"> $NtpcCron");
		print NTCRON <<EOF;
#!/bin/sh

# NTPdate cron event
# Configured through the administrative web interface
# Copyright (C) 1998, Cobalt Networks, Inc
# All rights reserved

$NtpDate $server >>$Sauce_log 2>&1
EOF
		close(NTCRON);
		chmod(0700,"$NtpcCron");

		return "2714 ntpc updates scheduled successfully";
	} else
	{
		unlink("$NtpcCron") if (-e "$NtpcCron");
		unlink("$NtpcConf") unless ($server);
		return "2715 ntpc scheduled updates disabled successfully";
	}
}


1;
