# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Time.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Alias_db = "/etc/aliases.db";
my $Clock_cmd = "/sbin/clock";
my $Cron_script = "/etc/rc.d/init.d/cron.init";
my $Custo_pid = "/var/run/custodiat.pid";
my $Date_cmd = "/bin/date";
my $Issuefile = "/etc/issue";
my $Sauce_log = "/var/cobalt/sauce.log";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Time.pm.  Changes made here will be lost.
package Cobalt::Time;

sub set_time
# Set the time and date
# Arguments: An array containing the month (0-11), the date (1-31), the
#   year (19xx or 20xx or whatever), the hour (0-23) and the minute (0-59)
# Side effects: sets the system clock
# Return value: Returns a string of the form "889 Not enough string"
{
    return "4486 Invalid time format" if (grep(/[^\d]/o,@_));
    my ($month,$date,$year,$hour,$minute) = @_;
    $month++;
    system("$Date_cmd --set='$month/$date/$year $hour:$minute' >>$Sauce_log 2>&1") &&
	return "4480 Cannot set date: $!";
    system("$Clock_cmd -w >>$Sauce_log 2>&1") &&
	return "4481 Cannot save date: $!";
    $^T = time();
    # Fix the timestamp in /etc/issue, because monitor uses it
    # to tell how long ago we finished booted up
    utime($^T,$^T,$Issuefile);
    # Fix the timestamp on the aliases db, because we auto-rebuild 
    # based on it being older than /etc/aliases
    utime($^T,$^T,$Alias_db) if ($Features{'mail'});

    # Restart crond in a child process
    my $pid;
    if (!defined($pid = fork)) {
	die "cannot fork: $!";
    } elsif ($pid) {
	# i'm the parent
	print STDERR "Forking to restart crond\n" if ($Debug);
	return "2039 Date set";
    }
    else
    {
	# otherwise I'm the child
	open(STDERR,">>$Sauce_log");
	open(STDOUT,">>$Sauce_log");
	system("$Cron_script stop >>$Sauce_log 2>&1");
	system("$Cron_script start >>$Sauce_log 2>&1");

	# Signal custodiat to wake up so we avoid eternal sleep...
	open(CUSTOPID,"$Custo_pid");
	my $cpid = <CUSTOPID>;
	close CUSTOPID;
	kill('ALRM',$cpid) if ($cpid);
	exit;
    }
}


1;
