# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Htptmp = "/etc/locks/htptmp";
my $Lockdir = "/etc/locks";
my $Ptmp = "/etc/ptmp";
my $Smbptmp = "/etc/locks/smbptmp";
my %Features = ("networker","1","telnetConfig","0","dhcpd","1","shiftjis","Cobalt interface message for shiftjis (We should never see this)","pagebuilder","1","www","1","mx","1","gated","1","dns","1","nfs","0","english","1","atalk","1","fpx","1","siteAdminRedirect","0","users","1","ntp","0","search","1","anonFTP","1","specialHomeSkel","0","viewGroups","1","cobaltHomePage","1","lastNameFirst","1","vsites","0","discuss","1","docorg","0","groups","1","nas","0","smb","1","mail","1","autoGenWebUsage","1","squid","0","japanese","0","cobaltRedirect","0","backups","1","vmachine","0","mon_port_testing","1","viewUsers","1","usersCGIInWizard","1","privatedirs","1","adm","1","siteManagement","0","ssl","0","personalRedirect","0","webRequests","1","usersAddUser","1","adminRedirect","1","quotas","1","snmp","1","defaultUserNameGen","1","groupdirs","1","proftpd","1");
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub unlock_passwd
# Unlocks the password file by wiping ptmp
# Arguments: none
# Side effects: wipes ptmp, htptmp
{
    unlink($Ptmp) || return "4512 Cannot delete password lock file /etc/ptmp: $!";
    unlink($Htptmp) || return "4513 Cannot delete web password lock file /etc/locks/htptmp: $!";
    if ($Features{'smb'}) {
      unlink($Smbptmp) || return "smb_cant_unlink_smbptmp Cannot unlink $Smbptmp: $!";
    }
    if ($Features{'atalk'}) {
      my $atalk_ret = Cobalt::Atalk::atalk_unlock_passwd();
      return $atalk_ret if ($atalk_ret !~ /^2/);
    }

    print STDERR "Removed $Ptmp, $Htptmp\n" if ($Debug);

    unlink("$Lockdir/user-$$");
    endpwent();  # flush the cache
    return "2513 Password file unlocked";
}


1;
