# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from User.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/User.pm.  Changes made here will be lost.
package Cobalt::User;

sub user_list_site
# Find out what site a user is in.
# Assuming the list groupName-users contains a list of users of group groupName
#   and a user can only belong to one groupName-users list
# Arguments: username
# Return value: fully qualified domain name of the site, group name
#   Nothing if nothing found
# Side effects: none
# Example: ( $domain, $group ) = Cobalt::User::user_list_site( 'kevin' );
{
    my ( $userName )=@_;

    my $domain;
    my $group;

    my @lists=Cobalt::List::list_sites_lists();
    my $list;
    foreach $list ( @lists ) {
	my ( $listName, @members )=@{ $list };
	if( grep /^$userName$/, @members ) {
	    if( $listName=~/^(.+)-users$/ ) {
		$group=$1;
		$domain=( Cobalt::Vhost::vsite_get( Cobalt::Vhost::vsite_get_bygroup( $group ) ) )[ 2 ];
		last;
	    }
	}
    }

    return ( $domain, $group );
}


1;
